#!/bin/bash

#################################################################
# Version 1.0 -- von M. Hagedorn, 26.09.2021

# Script zum Erzeugen der Dateien 2.csv und 3.csv, die benötigt
# werden, um automatisch die Teilnehmerlisten für 
# sophomorix-Projekte erstellen lassen zu können.

#################################################################

# Diese Variablen an die eigene Installation anpassen:

base="ou=default-school,ou=SCHOOLS,dc=linuxmuster,dc=lan"
server="ldaps://server.linuxmuster.lan:636"
binduser="global-binduser@linuxmuster.lan"
bindpw="super-geheimes-Passwort"
# cat /etc/linuxmuster/.secret/global-binduser

#################################################################

# NUR teacher ausgeben im Format: Login;ID (nicht vergeben!);Vorname;Name;
ldapsearch  -b "$base" -H $server -x -D $binduser -w $bindpw '(&(!(sophomorixAdminClass=attic))(|(sophomorixRole=teacher)))' |grep  -e sAMAccountName: -e sophomorixUnid: -e sophomorixFirstnameASCII: -e sophomorixSurnameASCII: | awk '{printf $2";"}  NR%4==0 {printf"\n"}' |sort -n > 3.csv

# und students ausgeben im Format: Login;Vorname;Name;ID; (Reihenfolge bei ldapsearch ist anders als bei Lehrern!)
ldapsearch  -b $base -H $server -x -D $binduser -w $bindpw '(&(!(sophomorixAdminClass=attic))(|(sophomorixRole=student)))' |grep  -e sAMAccountName: -e sophomorixFirstnameASCII: -e sophomorixSurnameASCII: -e sophomorixUnid: | awk '{printf $2";"}  NR%4==0 {printf"\n"}' |sort -n > 2.csv
