#!/bin/bash

######################################################################
# Version 1.0 - von M. Hagedorn
# nach einer Vorlage aus de.comp.os.unix.shell; 26.09.2021

# Dieses Script erzeugt aus den drei Files 
# 1.csv (alle bestehenden Kurse mit Lehrern, Schülern und SchülerID), 
# 2.csv (alle Schülernamen mit Login und ID) und 
# 3.csv (alle Lehrernamen mit Login aber ohne ID)
# eine neue Datei, in der alle existierenden Kurse in der Form
# KursID;Lehrerkürzel;Schülerkürzel1;Schülerkürzel2;...
# eingetragen werden.
######################################################################

echo
echo "########################################################"
echo "Ausgabe in Datei umleiten: > kursIDs_mit_UserIDs.csv "
echo "########################################################"
echo
echo "Alte Kursdatei wird entfernt: rm ./kursIDs_mit_UserIDs.csv"
rm ./kursIDs_mit_UserIDs.csv

OIFS="${IFS}"

# erstmal Teilnehmer einlesen und merken
# damit nur einmal gelesen werden muss
while read ZEILE2
do
  IFS=";"
  set -- $ZEILE2
  ARR_TEILNEHMER_ID=("${ARR_TEILNEHMER_ID[@]}"  "$4")
  ARR_TEILNEHMER_KURZ=("${ARR_TEILNEHMER_KURZ[@]}"  "$1")

done <2.csv

# dann Kursleiter einlesen und merken, Grund wie vor
while read ZEILE3
do
  IFS=";"
  set -- $ZEILE3
  ARR_LEITER_NAM=("${ARR_LEITER_NAM[@]}"  "$4")
  ARR_LEITER_VORNAM=("${ARR_LEITER_VORNAM[@]}"  "$3")
  ARR_LEITER_KURZNAM=("${ARR_LEITER_KURZNAM[@]}"  "$1")

done <3.csv

# nun Datei 1.csv Gruppe fuer Gruppe auswerten
IFS="${OIFS}"
for GRUPPE in $(cut -d ";" -f1,1 1.csv | uniq)
do
  AUSGABE=
  LEITER_NAME=$(grep "${GRUPPE};" 1.csv | head -1 | cut -d";" -f2,2)
  LEITER_VORNAME=$(grep "${GRUPPE};" 1.csv | head -1 | cut -d";" -f3,3)
  i=0
  for NAM in "${ARR_LEITER_NAM[@]}"
  do
    if [ "${ARR_LEITER_NAM[i]}" = "${LEITER_NAME}" -a "${ARR_LEITER_VORNAM[i]}" = "${LEITER_VORNAME}" ]
    then
      LEITER_KURZNAME="${ARR_LEITER_KURZNAM[i]}"
      break
    else
      ((i++))
    fi
  done

  while read ZEILE1
  do
    IFS=";"
    set -- $ZEILE1
    IFS="${OIFS}"
    if [ "$1" != "$GRUPPE" ]
    then
      continue
    fi

    TEILNEHMER_ID=$6

    i=0
    for NAM in "${ARR_TEILNEHMER_ID[@]}"
    do
      if [ "${ARR_TEILNEHMER_ID[i]}" = "${TEILNEHMER_ID}" ]
      then
        AUSGABE="${AUSGABE}${ARR_TEILNEHMER_KURZ[i]};"
      fi
      ((i++))
    done


    IFS="${OIFS}"

  done <1.csv
  AUSGABE="${GRUPPE};${LEITER_KURZNAME};${AUSGABE}"
  # Ausgabe auf Konsole
  echo $AUSGABE
  # und zusätzlich Umleiten in Datei:
  echo $AUSGABE >> kursIDs_mit_UserIDs.csv
done
