#!/bin/bash

#######################################################################
# Scriptname :    project_manager.sh 
# Author     :    Vorlage von Bernd Holzhauer; geändert von M.H.
# Date       :    2021-09-26
# Requires   :    dialog, exportierte CSV-Datei
# Category   :    geeignet für linuxmuster-Server 7.x
#Version     :
VER='1.1'
#######################################################################

# Variablen (don't edit!)
_temp="/tmp/answer.$$"
#PN=`basename "$0"`
#echo $PN
#dialog >$_temp
#DVER=`cat $_temp | head -1`
#echo $DVER
output="create-projects.csv"
output2="kill-projects.csv"
outtemp="create_temp.csv"
outtemp2="kill_temp.csv"

#Einzulesende CSV-Datei (entweder als Paramter übergeben):
#IDs=$1
#if [ -z "$1" ]
#  then
#    echo
#    echo "Syntax: $scriptpath/$filename <DATEINAME.CSV>"
#    echo
#    echo "CSV-Format: kursID,LehrerID,SchuelerID,"
#    echo "Bei uns: kursIDs_mit_UserIDs.csv"
#    echo 
#    exit 0;
#fi
#Test, ob Syntax richtig angegeben wurde:
#filename="${0##*/}"
#scriptpath=`pwd -P`

#Oder festen Dateinamen zuordnen:
IDs="./kursIDs_mit_UserIDs.csv"

#######################################################################

### Schritt I: Datei wird eingelesen und verarbeitet:
read_csv() {
rm -f ./$output
rm -f ./$output2

while IFS=";" read kursID lehrer;
do
  echo "Kurs: $kursID mit Lehrer: $lehrer wird generiert!"

# Optionen einbauen: --hide --nojoin

  echo -n "sophomorix-project -p p_kurs_$kursID --join --create --admins $lehrer --members " >> $outtemp
  echo -n "sophomorix-project -p p_kurs_$kursID --kill" >> $outtemp2
  while IFS=";" read kurs lehrer schueler;
  do
   if [[ $kurs == "$kursID" ]]; then 
   echo -n "$schueler," >> $outtemp
  fi
  done < <(cat $IDs |tr [:upper:]ÄÖÜ [:lower:]äöü )
  #Zeilenumbruch manuell einfügen:
  echo -en "\n" >> $outtemp
  echo -en "\n" >> $outtemp2

done < <(cat $IDs | cut -d";" -f1,2 |uniq |tr [:upper:]ÄÖÜ [:lower:]äöü)

#Zeilen numerieren in Ausgabefile!
awk '{ i += 1; if (length($0) > 0) {print i": "$0} else { print } }' $outtemp > $output
awk '{ i += 1; if (length($0) > 0) {print i": "$0} else { print } }' $outtemp2 > $output2
rm -f ./$outtemp
rm -f ./$outtemp2
}

#########################################################################

### Untermenu 1 ###
create_project() {
rm -f /tmp/options

#Die Checkliste benötigt drei Parameter: kurs, lehrer, on/off
Zaehler=0
while IFS=";" read kursID lehrer;
do
  Zaehler=$((Zaehler+1))
  echo "$Zaehler $kursID..............$lehrer off" >>/tmp/options
done < <(cat $IDs | cut -d";" -f1,2 |uniq |tr [:upper:]ÄÖÜ [:lower:]äöü)

OPTIONS=`cat /tmp/options`
choices=`/usr/bin/dialog --backtitle "Projekt-Manager $VER" --stdout --checklist 'Anzulegende Projekte auswählen:' 30 55 25 ${OPTIONS}`

if [ $? -eq 0 ]
then
 for choice in $choices
do
  #Anführungszeichen los werden:
  auswahl=$(echo $choice |sed 's/\"//g')
  while IFS=":" read nummer command; 
  do 
   if [[ $auswahl = "$nummer" ]]; then 
   #Zum Scharfstellen des Scriptes den Befehl "echo" in der folgende Zeile löschen!
   echo $command
  fi
  done < <(cat $output )
done
   echo "-----------------------------------------------------------------------------------------------"
   read -p "Any key to return to Menu."
else
    echo "Keine Auswahl! Ende!"
fi
}

### Untermenu 2 ###
delete_project() {
rm -f /tmp/options

#Die Checkliste benötigt drei Parameter: kurs, lehrer, on/off
Zaehler=0
while IFS=";" read kursID lehrer;
do
  Zaehler=$((Zaehler+1))
  echo "$Zaehler $kursID..............$lehrer off" >>/tmp/options
done < <(cat $IDs | cut -d";" -f1,2 |uniq |tr [:upper:]ÄÖÜ [:lower:]äöü)

OPTIONS=`cat /tmp/options`
choices=`/usr/bin/dialog --backtitle "Projekt-Manager $VER" --stdout --checklist 'Zu löschende Projekte auswählen:' 30 55 25 ${OPTIONS}`

if [ $? -eq 0 ]
then
 for choice in $choices
do
  #Anführungszeichen los werden:
  auswahl=$(echo $choice |sed 's/\"//g')
  while IFS=":" read nummer command;
  do
   if [[ $auswahl = "$nummer" ]]; then
   #Zum Scharfstellen des Scriptes den Befehl "echo" in der folgende Zeile löschen!
   echo $command
  fi
  done < <(cat $output2 )
done
   echo "-----------------------------------------------------------------------------------------------"
   read -p "Any key to return to Menu."
else
    echo "Keine Auswahl! Ende!"
fi
}

### Hauptmenu ###
main_menu() {
    dialog --backtitle " Sophomorix     Projekt-Manager     Version: $VER " --title "   Hauptmenu   "\
        --cancel-label "Exit" \
        --menu "Cursortasten [UP] [DOWN], [ENTER] zur Auswahl" 10 60 10\
        Anlegen "Projekte anlegen"\
        Löschen "Projekte löschen"\
        Quit "Exit" 2>$_temp

    opt=${?}
    if [ $opt != 0 ]; then rm $_temp; exit; fi
    menuitem=`cat $_temp`
    echo "menu=$menuitem"
    case $menuitem in
        Anlegen) create_project;;
        Löschen) delete_project;;
        Quit) rm $_temp; exit;;
    esac
}

read_csv

while true; do
   main_menu
done
